\ Extremely complicated die-roll method for combat taken from the game
\ Silent Death:
\ Three dice are rolled.
\ If their sum is above a target, the roll is a hit.
\ To calculate damage, the same dice are sorted.
\ If all three are equal, all are added to yield the damage.
\ If the two lowest are equal, but the third is higher, the high die
\ is the damage.
\ If the two highest are equal, but the third is lower, the two high
\ dice are added to yield the damage.
\ If they are all different, the middle die is the damage.

\ The below example assumes the dice are two d8 and a d10 and that the
\ target number is 15.

let x = 2#d8 @ d10 in
(count >15 sum x)#
  let a = least 1 x in            \ low die
  let b = largest 1 least 2 x in  \ middle die
  let c = largest 1 x in          \ high die
    if =a =b c then a+b+c         \ all equal
    else if =a <c b then c        \ two low equal
    else if >a =c b then b+c      \ two high equal
    else b                        \ all different

