structure Syntax =
struct

  type pos = int * int       (* position in program (line,column) *)

  datatype Exp = NUM of int * pos 
	       | ID of string * pos   
	       | PLUS of Exp * Exp * pos   
	       | MINUS of Exp * Exp * pos   
	       | TIMES of Exp * Exp * pos   
	       | DIVIDE of Exp * Exp * pos    
	       | UMINUS of Exp * pos
	       | CONC of Exp * Exp * pos 
	       | D of Exp * pos      
	       | SUM of Exp * pos
	       | COUNT of Exp * pos
	       | LEAST of Exp * Exp * pos
	       | LARGEST of Exp * Exp * pos
	       | HASH of Exp * Exp * pos
	       | EQ of Exp * Exp * pos
	       | LT of Exp * Exp * pos
	       | GT of Exp * Exp * pos
	       | LE of Exp * Exp * pos
	       | GE of Exp * Exp * pos
	       | FROMTO of Exp * Exp * pos
	       | LET of string * Exp * Exp * pos 
	       | REPEAT of string * Exp * Exp * pos 
	       | FOREACH of string * Exp * Exp * pos
	       | IF of Exp * Exp * Exp * pos

end
